++include ashinc:ashell.def
++include ashinc:infld.sdf

DEFSTRUCT ST_INFCLXMAX
	map2 xmax'structure, ST_INFXMAX
	map2 color'structure, ST_INFCLRX
	map2 rgpd'mode,b,1
ENDSTRUCT

map1 super'structure, ST_INFCLXMAX
super'structure.xmax'structure.ecol =  30000 

defstruct ST_fields
map2 item$
   map3 label$,s,30
   map3 type$,s,30
   map3 value$,s,200
endstruct

dimx $countries, ordmap(varstr; varstr)
$countries("-3001") = "~ ~ ~PT~Portugal~FR~France~ES~Spain~IT~Italy~DE~Germany~~"
$countries("-3002") = "~ ~ ~US~USA~CN~Canada~BR~Brazil~~"
$countries("-3003") = "~ ~ ~SA~South Africa~NZ~New Zeland~~"

dimx fields(4),ST_fields, AUTO_EXTEND
dimx list$(4),s,0,AUTO_EXTEND

? tab(-1, 0)

fields(1).label$ = "^Country | (only producers)" 
fields(1).type$ = ""                   ! input field but switch to list code-descr when tabcontrol is active
list$(1) = ""

fields(2).label$ = "<1>" + "Type"
fields(2).type$ = "||L"                ! list code-descr
list$(2) = "~R~Red~W~White~~"

fields(3).label$ = "|" + "Grape"
fields(3).type$ = "|L"                 ! list w/o code
list$(3) = "~ ~Nebbiolo~Gamay~Touriga Nacional~Grenache~Malbec~Syrah~Merlot~Pinot Noir~Cabernet Sauvignon~~"

fields(4).label$ = "Brand"
fields(4).type$ = ""
list$(4) = "..."           ! self-combo

fields(5).label$ = "|>" + "Only blends"         ! checkbox
fields(5).type$ = ""
list$(5) = ""

map1 i,f
map1 dlg'id,b,4
map1 dlg'parent'id,b,4
map1 parent'id$,s,30

DEFINE VIEW_ = 2
DEFINE EDIT_ = 1
map1 CRLF$,s,0,chr(13)+chr(10)

main'program:

   parent'id$ = "dlg'wine"
   xcall AUI, AUI_CONTROL, CTLOP_ADD, parent'id$ , "Wines of the world", 0, &
                                       MBF_DIALOG+MBF_SYSMENU+MBF_DLGNOCREEP+MBF_ALTPOS+MBF_MAXBUTTON, "", "", dlg'id, &
                                       3500, 7000, 25500, 76000, -2, -2, 0, 0, "", "", dlg'parent'id, &
                                       NUL_WINCLASS$, NUL_WINSTYLE, NUL_WINSTYLEX, (MBF2_DLGSTATE OR MBF2_DLGICON OR MBF2_RESIZE OR MBF2_MINBUTTON)

    parent'id$ = "tab'wine"
    xcall AUI, AUI_CONTROL, CTLOP_ADD, parent'id$, "Europe~VK_xF3001~~USA~VK_xF3002~~South~VK_xF3003~~", 0, &
                                    MBF_TAB+MBF_KBD, " VK_xF3001, VK_xF3002, VK_xF3003", "", 0, &
                                    2000, 2000, 17000, 50000, 4294967294, -2
    list$(1) = $countries(-3001)
    fields(1).type$ = "||L||S"
    
   call FN'loop'fields(mode=VIEW_)
   
   do 
      if FN'loop'fields(mode=EDIT_)=0 then
         exit
      endif
   loop
   
   ? tab(-1, 0)
end


FUNCTION FN'loop'fields(mode as b1)
++pragma auto_extern
map1 exitcode,f
   
   .FN = 1
     
   for i=1 to .extent(fields())
      super'structure.xmax'structure.erow =  3000 + (i - 1) * 2000

      exitcode = FN'field(mode, i)
      
      if mode=EDIT_ then
         SWITCH exitcode
         CASE 1
            .FN = 0
            i = 9000
            exit
         CASE 29
            xcall MSGBOX, "You clicked the SELF-COMBO ... execute whatever you want to display a long list of oprions.", "Self-combo", MBTN_OK, MBICON_ICON
            exit
         CASE -199...-101              ! field clicks
            i = abs(exitcode) - 101
            exit
         CASE -399...-301              ! label buttons clicks 
            xcall MSGBOX, "You clicked on the Label button of field #" $+ (abs(exitcode)-300) $+ " feel free to add some routine here.", "Label button", MBTN_OK, MBICON_ICON
            exit
         CASE -3099...-3001              ! tab control panes
            xcall MSGBOX, "You can clear the tabcontrol area to display new fields or just handle the click to filter data." + CRLF$ + &
                          "In this case I'm just using it to adjust my countries list.", "Panels", MBTN_OK, MBICON_ICON
            i = 0
            list$(1) = $countries(exitcode)
            exit
         DEFAULT
            Trace.Print "FN'loop'fields() exitcode=["+exitcode+"]"
            exit
         ENDSWITCH
      endif
   next i
  
ENDFUNCTION


FUNCTION FN'field(op as b1, field'seq as b4) as f6
++pragma auto_extern
map1 sl,b,4
map1 exitcode$,s,3

      sl = super'structure.xmax'structure.erow - 1000 
      exitcode$ = 100 #+ field'seq
      
      xcall SBXINP, fields(i).label$, op, sl, 6000, super'structure, fields(i).value$, fields(i).type$, list$(i), 60, exitcode$, "tooltip", parent'id$, .FN, 0

ENDFUNCTION

